from Products.ZPhotoSlides import CMFPhoto, CMFPhotoSlides, CMFPhotoSlidesFolder, install_globals

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName

from AccessControl.Permission import pname
import Globals

from cStringIO import StringIO
import string


fti_list = (
    CMFPhoto.factory_type_information,
    CMFPhotoSlides.factory_type_information,
    CMFPhotoSlidesFolder.factory_type_information,
   )
types_list = (
    "ZPhoto",
    "ZPhotoSlides",
    "ZPhotoSlidesFolder",
   )

# portal_form_controler actions:
#     (id, status, context_type, button, action_type, args)
form_actions = (
    ('folder_rename','success','ZPhotoSlides',None,'redirect_to','string:zphotoslides_contents'),
   )

use_folders_tabs = ("ZPhotoSlidesFolder",)

skin_name = "zphotoslides"
perms_list = ("Add portal content", )


def installSubSkin(self, out, skinFolder):
    """ Install a subskin, i.e. a folder/directoryview.
    """
    skinsTool = getToolByName(self, 'portal_skins')

    for skin in skinsTool.getSkinSelections():
        path = skinsTool.getSkinPath(skin)
        path = map( string.strip, string.split( path,',' ) )
        if not skinFolder in path:
            try:
                path.insert( path.index( 'custom')+1, skinFolder )
            except ValueError:
                path.append(skinFolder)
            path = string.join( path, ', ' )
            skinsTool.addSkinSelection( skin, path )
            out.write('Subskin successfully installed into %s.\n' % skin)    
        else:
            out.write('*** Subskin was already installed into %s.\n' % skin) 


def setupTypesandSkins(self, out):
    typesTool = getToolByName(self, 'portal_types')
    skinsTool = getToolByName(self, 'portal_skins')
    
    # Former types deletion (added by PJG)
    for f in fti_list:
        if f['id'] in typesTool.objectIds():
            out.write('*** Object "%s" already existed in the types tool => deleting\n' % (f['id']))
            
            typesTool._delObject(f['id'])

    # Type re-creation
    for f in fti_list:
        cfm = apply(ContentFactoryMetadata, (), f)
        typesTool._setObject(f['id'], cfm)
        out.write('Type "%s" registered with the types tool\n' % (f['id']))

    # portal_form_controler actions. We can't use .metadata to overide plone actions.
    portal_form_controller = getToolByName(self, 'portal_form_controller')
    for (id, status, context_type, button, action_type, args) in form_actions:
        portal_form_controller.addFormAction(id,
                                             status,
                                             context_type,
                                             button,
                                             action_type,
                                             args)
        
    # Install de chaque nouvelle subskin/layer
    try:  
        addDirectoryViews(skinsTool, 'skins', install_globals)
        out.write( "Added directory views to portal_skins.\n" )
    except:
        out.write( '*** Unable to add directory views to portal_skins.\n')

    # Param de chaque nouvelle subskin/layer
    installSubSkin(self, out, skin_name)

def setupSiteProperties(self,out):
    p = getToolByName(self, 'portal_properties')
    sp = p['site_properties']
    use_folder_tabs = sp.use_folder_tabs
    for f in use_folders_tabs:
        if not f in use_folder_tabs:
            try:
                use_folder_tabs.append(f)
            except:
                use_folder_tabs = use_folder_tabs + (f,)
    sp.use_folder_tabs = use_folder_tabs
    out.write( "Added properties to portal_properties/site_properties.\n" )
    
def install(self):
    out=StringIO()
    setupTypesandSkins(self, out)
    setupSiteProperties(self,out)
    out.write('Installation completed.\n')
    return out.getvalue()

