# ZPhotoSlides, Zope product
# Copyright (C) 2002-2003  Jean-Francois Roche <jfroche@jfroche.be>
#                          Florent Carlier <florent.carlier@insa-rennes.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: ZPhotoSlidesUtils.py,v 2.8 2004/08/19 10:10:44 gawel Exp $'

import string,os,sys
from config import *
#from AccessControl import ModuleSecurityInfo, getSecurityManager

#security = ModuleSecurityInfo()

VERSION='2.0'
DATE='2004-18-08'

valid_anim_ext = ('mov','rm','ram','swf','mpe','mpeg')
valid_pic_ext = ('jpg','gif','png','pif','bmp')
valid_ext = valid_anim_ext + valid_pic_ext

zps_meta_types = ['ZPhotoSlides','CMF ZPhotoSlides']
zpsfolder_meta_types = ['ZPhotoSlides Folder','CMF ZPhotoSlides Folder']
zpsfolderish_meta_types = zps_meta_types + zpsfolder_meta_types
zp_meta_types = ['ZPhoto','CMF ZPhoto']


def updateVisited(self):
    req = self.REQUEST
    resp = req.RESPONSE
    idfolder = str(self.getId())
    if not(req.cookies.has_key('visited'+ idfolder)):
       resp.setCookie('visited'+ idfolder, 1)
       self.visited(req)
       return 1
    return 0

def gettext(msg):
    return msg

def zpsgettext(msg):
    return msg
    
def parse_ext(self,s):
    name,ext = os.path.splitext(s)
    return ext[1:]

def find_Localizer(obj=None):
    try:
        import Products.Localizer
        return 1
    except:
        return 0

def find_Stripogram(obj=None):
    try:
        import Products.stripogram
        return 1
    except:
        return 0

def find_Pil(obj=None):
    ''' return true if we have PIL lib '''
    try:
        import PIL
        return 1
    except:
        return 0



def find_convert(obj=None):
    ''' find convert binary '''
    if CONVERT_LOCATION:
        if os.path.isfile(CONVERT_LOCATION):
            return CONVERT_LOCATION
        else:
            raise IOError,'No such file %s. You need to change the CONVERT_LOCATION in ZPhotoSlides/config.py' % CONVERT_LOCATION
    if(os.name == 'posix'):
        # try with which
        path = os.popen('which convert').readline()[:-1]
        if path != '': return path
    # else explore PATH
    if sys.platform == 'win32': convert = 'convert.exe'
    else: convert = 'convert'
    paths = os.environ.get('PATH').split(os.pathsep)
    for p in ('/usr/bin','/usr/sbin','/usr/local/bin','/usr/local/sbin'):
        if p not in paths: paths.append(p)
    for path in paths:
        if os.path.isdir(path):
            files = os.listdir(path)
            if convert in files:
                return os.path.join(path,convert)
    return ''
    #if(os.name == 'posix'):
    #    for elem in ('/usr/bin/convert','/usr/sbin/convert','/usr/local/bin/convert'):
    #        if(os.path.isfile(elem)):
    #            return elem
    #return ''


def find_tmp_folder(self=None):
    ''' return a tmp dir '''
    if TMP_DIR:
        if os.path.isdir(TMP_DIR):
            return TMP_DIR
        else:
            raise IOError,'No such directory %s. You need to change the TMP_DIR in ZPhotoSlides/config.py' % TMP_DIR
    if(os.name == 'posix'):
        #always /tmp in posix os
        return '/tmp' 
    else:
        # try with en var
        path = os.environ.get('TEMP')
        if path: return path
        # else with random path..
        for tmpdir in ('c:\Tmp','c:\windows\Temp','c:\winnt\Temp','c:\\'):
            if(os.path.isdir(tmpdir)):
                return tmpdir
                break
    return ''

have_PIL = find_Pil()
have_IM = find_convert()

def get_img_lib(self=None):
    ''' return the img lib used '''
    if FORCE_IMAGE_LIBRARY:
        # return the config lib
        if FORCE_IMAGE_LIBRARY in ('IM','PIL'):
            return FORCE_IMAGE_LIBRARY
        else:
            raise 'ConfigError','The lib %s can\'t be used. You need to change the FORCE_IMAGE_LIBRARY in ZPhotoSlides/config.py' % FORCE_IMAGE_LIBRARY
    else:
        if self:
            # return the object lib property
            return self.lib
        else:
            # try to get one (default PIL)
            if have_PIL:
                return 'PIL'
            elif have_IM:
                return 'IM'
    # Else... None...
    return None
        
have_stripogram = find_Stripogram()
have_localizer = find_Localizer()
tmp_folder = find_tmp_folder()


# Protection Text : Strip-o-Gram HTML Conversion Library
if find_Stripogram():
        from Products.stripogram import html2safehtml
else:
        from Products.PythonScripts.standard import html_quote
        def html2safehtml(s, valid_tags=('b', 'a', 'i', 'br', 'p')):
	        return html_quote(s)

def zpsconfig():
    ''' return zps config as dict '''
    sizes = [(v,k) for k,v in DEFAULT_SIZES.items()]
    sizes.sort()
    sizes = [k for v,k in sizes]
    formats = {}
    for (k,v) in DEFAULT_SIZES.items():
        formats[k] = {'name':k,'size':v,'used':0,'location':'zodb'}
    for f in ('full','thumb',DEFAULT_FORMAT):
        formats[f]['used'] = 1
    sorted_formats = []
    for size in sizes:
        sorted_formats.append(formats[size])
    return {
            'ACCESS_FS':ACCESS_FS,
            'UPLOAD_FS_PHOTOS':UPLOAD_FS_PHOTOS,       #deprecated
            'DEFAULT_SIZES':formats,                   # a dict of size:{name:'',size:'',etc.}
            'DEFAULT_SORTED_SIZES':sorted_formats,     # a list of {name:'',size:'',etc.}
            'FORCE_IMAGE_LIBRARY':FORCE_IMAGE_LIBRARY,
            'TMP_DIR':TMP_DIR,                         # a tmp dir if admin want to force any
            'CONVERT_LOCATION':CONVERT_LOCATION,       # a path to convert if admin want to force any
           }

                                       


__all__ = (
           'have_stripogram','have_localizer','have_PIL','have_IM','get_img_lib','tmp_folder',
           'find_tmp_folder','find_convert',
           'updateVisited','parse_ext','html2safehtml',
           'valid_anim_ext','valid_pic_ext','valid_ext',
           'zps_meta_types','zpsfolder_meta_types','zp_meta_types','zpsfolderish_meta_types',
           'zpsconfig',
           'VERSION','DATE',
           )

#security.declarePublic(
#        'have_stripogram','have_localizer','have_PIL','have_IM','tmp_folder',
#        'zpsconfig'
#        )
#security.apply(globals())
