#!/usr/bin/python
# ZPhotoSlides Folder - ZPhotoSlides - ZPhoto Config File
###
# Does ZPhotoSlides can access to the FS of the Zope server?
# 1 = yes (default)
# 0 = no
ACCESS_FS = 1
###
###
# If ZPhotoSlides can access FS, if photo is on FS should we
# upload it into ZODB?
# 0 = no (default, never use FS)
# 1 = yes (always use FS)
# 2 = user defined
UPLOAD_FS_PHOTOS = 2
###
###
# Default sizes of all the thumbnails
# This is a dictionary, key is the name of the size, information is the size
# (photo size = size x size)
# Don't remove the thumb and full size
DEFAULT_SIZES = {'thumb':200,'small':320,'medium':480,'large':768,'full':99999}
###
###
# The default format for zphoto/view
DEFAULT_FORMAT = 'medium'
###
###
# In case if you have all Image Library (yet PIL and Image Magick)
# Oblige ZPhotoSlides to use an Image Library 
# 'PIL' = You want to use PIL
# 'IM' = You want to use IM
FORCE_IMAGE_LIBRARY = ''
###

###
# If you force Image Magick (FORCE_IMAGE_LIBRARY='IM') give here the location of convert on the file system
# Put None if you don't want to force the Image Magick location
# Put '/usr/bin/convert' for example if you want to force the use of this convert
CONVERT_LOCATION = None
###
###
# Allow access mailhost object to send postcard via email?
# 0 = no 
# 1 = yes - user defined (default)
POSTCARD_ACCESS = 1
###
###
# Allow user to export your photo to another format
# size
# 0 = no
# 1 = yes - user defined (default)
EXPORT_ACCESS = 1
###
###
# Force mailhost host: use the fallowing server to send
# the mails
# example: 'localhost' 
#          'mail.yourhost.com'
# set None to not force a mailhost
FORCE_MAILHOST = None
###
###
# A fixe temp directory (for image transform etc.)
# Set it if you wan't to force users to use one
TMP_DIR = ''
###
###
# A Max size of each ZPhotoSlides in Kilobyte
# ZPhotoSlides can grow ZODB quite quickly if lot's of users
# 0 = unlimited (no max size)
# ex: 10000
MAX_SIZE = 0
###
