#!/usr/bin/env python
# ZPhotoSlides, Zope product
# Copyright (C) 2002-2003  Jean-Francois Roche <jfroche@jfroche.be>
#                          Florent Carlier <florent.carlier@insa-rennes.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: IMG_IM_start.py,v 2.1 2004/07/16 12:13:33 jfroche Exp $'

#  Create thumbnails using ImageMagick

from IMG_fileobj import FileObj
import os, sys
import dircache
import string
#import exiftool
import exif

def thumbnail_IM(path,destination,width=200,height=200,prefix='tn_'):
	prefix_size=len(prefix)
	init_path,imgname = os.path.split(path)
#	print init_path
	#Im = Img(path)
	try:
		fd = open(path,'r')
	except:
		errormsg = '\\Error:'
		for i in sys.exc_info():
			errormsg = errormsg + '   ' + str(i)
		dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
	else:
		#if(hasattr(Im,'im')): # if it's a valid image!
		#print "%s -format '%%m' %s" % (IM_identify,path) 
		#fd = os.system("%s -format '%%m' %s" % (IM_identify,path))
		format = string.strip(fd.read())
		if(format == "JPEG" or format == "GIF" or format == "PNG"):
			#print 'ok jpg or gif!'
			if(imgname[:prefix_size]!=prefix and imgname[-3:]!='bak'):
				oldname = imgname
				imgname = prefix + imgname
				dict[imgname] = path
				#print "tmp : %s " % dict[imgname] 
				dict[imgname] = dict[imgname][len(init_path)+1:]
				#print "tmp2 : %s " % dict[imgname]
				dest = os.path.join(destination,imgname)
				try:
					#Im.thumbnailize(width,height,prefix,dest)
					#str = '%s -geometry %ix%i -interlace LINE %s %s' % (IM_convert,width,height,path,dest)
					#print str
					res = os.system('%s -geometry %ix%i -interlace LINE %s %s' % (IM_convert,width,height,path,dest))
				except:
					errormsg = '\\Error in thumbnailizing:'
					for i in sys.exc_info():
						errormsg = errormsg + ' ' + str(i)
						dict[imgname] = imgname + ': ' + errormsg + '<br>'
				else:
					#print imgname[-3:]
					if(imgname[-3:] == 'JPEG' or imgname[-3:] == 'jpg' or imgname[-3:]=='JPG' or imgname[-3:]=='jpeg'):
                                                data = fd.read()
                                                fd.close()
						dict[imgname+'_info'] = exif.exif_parse(StringIO(data))
                                                dict[Im.imgname+'_iptc'] = iptc.getiptc_data(data)
                                                
	return dict


def thumbnails_IM(path,init_path,destination='/tmp/paula2',width=200,height=200,prefix='tn_',dict={},double_name=0,convert=''):
	prefix_size=len(prefix)
	amount = 0
	fo = FileObj(path)
	for i in fo.getBiggerFileList():
		#Im = Img(i[0])
		init,imgname = os.path.split(i[0])
		try:
			fd = open(i[0],'r')
		except:
			errormsg = '\\Error:'
			for i in sys.exc_info(): 
				errormsg = errormsg + '   ' + str(i)
			dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
		else:
			#print "%s -format '%%m' %s" % (identify,i[0])
			#os.system("%s -format '%%m' %s" % (identify,i[0]))
			
	                #format = string.strip(fd.read())
        	        #if(format == "JPEG" or format == "GIF" or format == "PNG"): # Valid image?
			if(imgname[:prefix_size]!=prefix and imgname[-3:]!='bak'):
# 				dont thumbnailize the thumbnails!!!
				oldname = imgname
				imgname = prefix + imgname
				if(dict.has_key(imgname) and double_name):#if file already in another directory we must rename it!
					if(dict.has_key('cpt__' + imgname)):# cpt exist already?
						dict['cpt__' + imgname] = dict['cpt__' + imgname] + 1
					else:
						# cpt dont exist yet for this file (first file with the same name)
						dict['cpt__' + imgname] = 0
						filename,extension=os.path.splitext(imgname)
						imgname = filename + str(dict['cpt__' +imgname]) + extension
				 
				dict[imgname] = os.path.join(path,oldname)
				dict[imgname] = dict[imgname][len(init_path)+1:]
				dest = os.path.join(destination,imgname)
				try:
				#	Im.thumbnailize(width,height,prefix,dest)
					#str1 = '%s -geometry %ix%i -interlace LINE %s %s' % (convert,width,height,i[0],dest)
					#print str1
					os.system('%s -geometry %ix%i -interlace LINE %s %s' % (convert,width,height,i[0],dest))
				except:
					errormsg = '\\Error in thumbnailizing:'
					for i in sys.exc_info():
						errormsg = errormsg + '   ' + str(i)
					dict[imgname] = imgname + ': ' + errormsg + '<br>'
				else:
					#print imgname[-3:]
					if(imgname[-3:] == 'JPEG' or imgname[-3:] == 'jpg' or imgname[-3:]=='JPG' or imgname[-3:]=='jpeg'):
						dict[imgname+'_info'] = exiftool.exif_parse(i[0])
					amount = amount + 1
	return dict,amount


def recursive_thumbnails_IM(path,init_path,destination,width=200,height=200,prefix='tn_',dict={},double_name=1,cpt=0,convert=''):
	dir = path
	dict,amount = thumbnails_IM(path,init_path,destination,width,height,prefix,dict,double_name,convert)
	cpt = cpt + amount
#	print 'Num: (%s)' % dir + str(cpt)
	list = os.listdir(dir)
	for elem in list:
		new_dir = os.path.join(dir,elem)
		if(os.path.isdir(new_dir) and os.access(new_dir,os.R_OK)):
			null, res = recursive_thumbnails_IM(new_dir,init_path,destination,width,height,prefix,dict,double_name,cpt,convert)
			cpt =res
	return dict,cpt

def thumbnails_manage_IM(path,convert,destination='/tmp',recursive=1,double_name=1,width=200,height=200,prefix='tn_',dict={}):
	if(path[-1] == '\\' or path[-1] == '/'):
		path = path[:-1]
	if(recursive):
		dict,amount = recursive_thumbnails_IM(path,path,destination,width,height,prefix,dict,double_name,0,convert)
	else:
		dict,amount = thumbnails_IM(path,path,destination,width,height,prefix,dict,0,convert)
	#print amount
	for elem in dict.keys():
		if(elem[:5]=='cpt__'): # remove count keys
			del dict[elem]
		else:	
			try:
				dict[elem] = dict[elem].replace('\\','/')
			except:
				pass
	return dict,amount
	
if __name__ == '__main__':
#	res, nombre = thumbnails_manage('/usr/photo2')
#	MakeJPG(sys.argv[1])
#	
#	MakeThumbnails(sys.argv[1])
#	a=MakeThumbnails()
#	dict= recursive_thumbnails('/tmp/toPaula','/tmp/paula2')
#	dict = thumbnails_manage('/var/zope/images','/tmp',1,1,dict)
#	print dict['cool.txt']
#	print 'Num: ' + str(nombre)
	dict = {}
	#dict = thumbnail('./manage_zphotoslides.jpg','/tmp')
#	dict = thumbnails('/usr/photo/screenshots','/usr/photo/screenshots',destination='/tmp/')
	dict = thumbnails_manage('/usr/photo/screenshots')
	print dict
