#!/usr/bin/python

# ZPhotoSlides, Zope product
# Copyright (C) 2002-2003  Jean-Francois Roche <jfroche@jfroche.be>
#                          Florent Carlier <florent.carlier@insa-rennes.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: IMG_img.py,v 2.1 2004/07/16 12:13:33 jfroche Exp $'


import os, sys, copy
import PIL.Image
import traceback
import time

class Img:
	
	def __init__(self, path):
		fullpath = os.path.abspath(os.path.normpath(path))
		self.imgpath = fullpath
		self.imgname = os.path.basename(self.imgpath)
		self.basepath = os.path.dirname(self.imgpath)
	
	def open_image(self):
			self.im = PIL.Image.open(self.imgpath)
			self.imgformat = self.im.format		# JPEG, GIF, ...
			self.imgmode = self.im.mode			# mode P, mode RGB, ...

	def getimgpath(self):
		return self.imgpath

	def getimgsize(self):
		return self.im.size
	
	def getStat(self):
		stat_list = []
		stat_list = os.stat(self.imgpath)
		return stat_list
	
	def getLastModif(self):
		a = self.getStat()
		return time.ctime(a[8])
	
	def getimgwidth(self):
		return self.im.size[0]
	
	def getimgheight(self):
		return self.im.size[1]

	def getimgweight(self):
		return os.path.getsize(self.imgpath)
	
	def save_to(self,location):
		try: # make a backup of the old photo before modif
			self.im.save(location)
		except:
			print "eh merde"
			for i in sys.exc_info(): print "%s" % (i)

	def thumbnailize(self, width,height, prefix,output):
		""" 'size' is the width of the thumbnail.
                     prefix is the name of the beginning of the thumbnail files
			'output' is an optional path where the thumbnail will be saved.
		"""
		self.size = (width, height)
#		print 'width : ' + str(width)
#		print 'height : ' + str(height)
		self.thumbname = "%s%s"%(prefix,self.imgname)
		self.thumbname = prefix + self.thumbname
		default = os.path.join(self.basepath, self.thumbname)
		self.output = output
		self.im.thumbnail(self.size)
	        self.im.save(self.output)

	def __str__(self):
		fileinfo = "Filename = %s\nFilepath = %s"%(self.imgname, self.basepath)
		imginfo = "\nFormat : %s\nMode : %s"%(self.im.format, self.imgmode)
		imgsize = "\nWidth = %d pixels\nHeight = %d pixels"%(self.im.size[0], self.im.size[1])
		imgweight = "\nFilesize = %s bytes"%(self.getimgweight())
		total = fileinfo + imginfo + imgsize + imgweight
		return total

def saveThumbnailInThumbDirectory(image, thumbsize):
	thumbdir = "thumb"
	thumbname = "tn_%s"%(image.imgname)
	dirpath = os.path.join(image.basepath, thumbdir)
	if not os.path.exists(dirpath):
		os.mkdir(dirpath)
	thumbpath = os.path.join(dirpath, thumbname)
	image.resize(thumbsize, thumbpath)

def main():
	test = "./b.jpg"
	a = Img(test)
	a.thumbnailize(120)
	saveThumbnailInThumbDirectory(a, 120)

if __name__ == "__main__":
	main()
