#!/usr/bin/env python

# ZPhotoSlides, Zope product
# Copyright (C) 2002-2003  Jean-Francois Roche <jfroche@jfroche.be>
#                          Florent Carlier <florent.carlier@insa-rennes.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: IMG_start.py,v 2.1 2004/07/16 12:13:33 jfroche Exp $'

from IMG_fileobj import FileObj
from IMG_img import Img
import os, sys
import dircache
#import exiftool
#import iptctool
import exif
import iptc

def thumbnail(path,destination,width=200,height=200,prefix='tn_'):
	prefix_size=len(prefix)
	init_path = os.path.split(path)[0]
	print init_path
	Im = Img(path)
	try:
		Im.open_image()
	except:
		errormsg = '\\Error:'
		for i in sys.exc_info():
			errormsg = errormsg + '   ' + str(i)
		dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
	else:
		if(hasattr(Im,'im')): # if it's a valid image!
			if(Im.imgname[:prefix_size]!=prefix and Im.imgname[-3:]!='bak'):
				oldname = Im.imgname
				Im.imgname = prefix + Im.imgname
				dict[Im.imgname] = path
				dict[Im.imgname] = dict[Im.imgname][len(init_path)+1:]
				dest = os.path.join(destination,Im.imgname)
				try:
					Im.thumbnailize(width,height,prefix,dest)
				except:
					errormsg = '\\Error in thumbnailizing:'
					for i in sys.exc_info():
						errormsg = errormsg + ' ' + str(i)
						dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
				else:
					if(Im.imgformat == 'JPEG'):
                                                fd = open(path)
                                                data = fd.read()
                                                fd.close()
						dict[Im.imgname+'_info'] = exif.exif_parse(data)
                                                dict[Im.imgname+'_iptc'] = iptc.getiptc_data(data)

                                                #res = iptc._getfilteredIPTCfields(Im.im)
                                                #for i in res:
                                                #    if(i[1]!=''):# add only iptc if there is
                                                                 # iptc infos!
                                                #        dict[Im.imgname+'_iptc'] = res
                                                #        break


	return dict


def thumbnails(path,init_path,destination,width=200,height=200,prefix='tn_',dict={},double_name=0):
	prefix_size=len(prefix)
	amount = 0
	fo = FileObj(path)
	for i in fo.getBiggerFileList():
		Im = Img(i[0])
		try:
			Im.open_image()
		except:
			errormsg = '\\Error:'
			for i in sys.exc_info(): 
				errormsg = errormsg + '   ' + str(i)
			dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
		else:
			if(hasattr(Im,'im')): # if it's a valid image!
				if(Im.imgname[:prefix_size]!=prefix and Im.imgname[-3:]!='bak'):
	# 				dont thumbnailize the thumbnails!!!
					oldname = Im.imgname
					Im.imgname = prefix + Im.imgname
					if(dict.has_key(Im.imgname) and double_name):#if file already in another directory we must rename it!
						if(dict.has_key('cpt__' + Im.imgname)):# cpt exist already?
							dict['cpt__' + Im.imgname ] = dict['cpt__' + Im.imgname] + 1
						else:
							# cpt dont exist yet for this file (first file with the same name)
							dict['cpt__' + Im.imgname] = 0
							filename,extension=os.path.splitext(Im.imgname)
							Im.imgname = filename + str(dict['cpt__' +Im.imgname]) + extension
					 
					dict[Im.imgname] = os.path.join(path,oldname)
					dict[Im.imgname] = dict[Im.imgname][len(init_path)+1:]
					dest = os.path.join(destination,Im.imgname)
					
					try:
						Im.thumbnailize(width,height,prefix,dest)
					except:
						errormsg = '\\Error in thumbnailizing:'
			                        for i in sys.exc_info():
                        		        	errormsg = errormsg + '   ' + str(i)
						dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
					else:
						if(Im.imgformat == 'JPEG'):
							dict[Im.imgname+'_info'] = exiftool.exif_parse(Im.getimgpath())
                                                        res = iptctool._getfilteredIPTCfields(Im.im)
                                                        for i in res:
                                                            if(i[1]!=''):# add only iptc if there is
                                                                         # iptc infos!
                                                                dict[Im.imgname+'_iptc'] = res
                                                                break

						amount = amount + 1
	return dict,amount


def recursive_thumbnails(path,init_path,destination,width=200,height=200,prefix='tn_',dict={},double_name=1,cpt=0):
	dir = path
	dict,amount = thumbnails(path,init_path,destination,width,height,prefix,dict,double_name)
	cpt = cpt + amount
	list = os.listdir(dir)
	for elem in list:
		new_dir = os.path.join(dir,elem)
		if(os.path.isdir(new_dir) and os.access(new_dir,os.R_OK)):
			null, res = recursive_thumbnails(new_dir,init_path,destination,width,height,prefix,dict,double_name,cpt)
			cpt =res
	return dict,cpt

def thumbnails_manage(path,destination='/tmp',recursive=1,double_name=1,width=200,height=200,prefix='tn_',dict={}):
	if(path[-1] == '\\' or path[-1] == '/'):
		path = path[:-1]
	if(recursive):
		dict,amount = recursive_thumbnails(path,path,destination,width,height,prefix,dict,double_name,0)
	else:
		dict,amount = thumbnails(path,path,destination,width,height,prefix,dict,0)
	for elem in dict.keys():
		if(elem[:5]=='cpt__'): # remove count keys
			del dict[elem]
		else:	
			try:
				dict[elem] = dict[elem].replace('\\','/')
			except:
				pass
	return dict,amount
    
def uploadOriginals(self,path):
    prefix = [i['name'] for i in self.getFormats()]
    dir = path
    list = os.listdir(dir)
    for elem in list:
        pref = elem[:elem.find('_')]
        if pref not in prefix:
            img_dir = os.path.join(dir,elem)
            if elem[-4:].lower() in ('.jpg','.gif','.png'):
                if self.portal_type:
                    self.invokeFactory('ZPhoto',elem,RESPONSE=None)
                    self[elem].update_data_from_fs(img_dir)
                else:
                    self.manage_addProduct['ZPhotoSlides'].manage_addZPhoto(elem,elem,path=img_dir)
                photo = self[elem]
                photo.filename = elem
                photo.dir = dir
                photo.path = img_dir
                photo._pre_thumbnailize()
    
if __name__ == '__main__':
#	res, nombre = thumbnails_manage('/usr/photo2')
#	MakeJPG(sys.argv[1])
#	
#	MakeThumbnails(sys.argv[1])
#	a=MakeThumbnails()
#	dict= recursive_thumbnails('/tmp/toPaula','/tmp/paula2')
#	dict = thumbnails_manage('/var/zope/images','/tmp',1,1,dict)
#	print dict['cool.txt']
#	print 'Num: ' + str(nombre)
	dict = {}
	dict = thumbnail('/usr/photo/manage_thumb.jpg','/tmp')
	print dict
