from PythonMagick import *
from PythonMagick.Drawable import *

class PM_Image_modif:
    def __init__(self,data):
        bl = Blob(data)
        self.im = Image(bl)
    def getrotate(self,angle):
        self.im.rotate(angle)
    def invert_image(self):
        self.im.negate(0)
    def save_to(self,location):
        self.im.write(location)
    def equalize(self):
        self.im.equalize()
    def transpose_left_right(self):
        self.im.flop()
    def sharpen(self):
        self.im.sharpen(1,0.3)
    def solarize(self,threshold):
        self.im.solarize(threshold)
    def change_Brightness(self,brightness):
        self.im.modulate(brightness,100,100)
    def resize_image(self,height,width,ratio=1):
        assert height!=0.0,  'Height is 0! Impossible!'
        assert width!=0.0, 'Width is 0! Impossible!'
        size = self.im.size
        size = "%ix%i" % (width,height)
        geo = Geometry(size)
        geo.aspect = 0
        self.im.sample(geo)

    def hex_to_rbg(self,string):
        a = int(string[1],16)
        b = int(string[2],16)
        c = int(string[3],16)
        d = int(string[4],16)
        e = int(string[5],16)
        f = int(string[6],16)

        x = (a * 16) + b;
        y = (c * 16) + d;
        z = (e * 16) + f;
        tuple = (x,y,z)
        return tuple
    def gettextcopyright(self, textcopy, textpos, textalign, textfont, textsize, textboldfont=0, textitalicfont=0, textcolor='#FF0000'):
        """copyright a photo with a given text

            boldfont:   0 ... normal font (the default)
                        1 ... bold font

            textpos:    The position of the copyright text can be specified by a string
                        containing a combination of one characters.  One character
                        must be either t, b or m.

            textalign:  The Alignemnt of the copyright text can be specified by a string
                        containing a combination of one characters.  One character
                        must be either l, c or r.

                    t ... top
                    b ... bottom
                    m ... middle

                    l ... left
                    c ... center
                    r ... right

                    The default value is 'bc'

        """
        width = self.im.size.width
        height = self.im.size.height
        drawList = []
        if textboldfont == '1':
            if textitalicfont == '1':
                drawList.append(Font("Garamond", StyleType.ItalicStyle, 0, StretchType.ExtraExpandedStretch))
            else:
                drawList.append(Font("Garamond", StyleType.NormalStyle, 0, StretchType.ExtraExpandedStretch))
#            font = ImageFont.load_path(boldfont)
        elif textitalicfont == '1':
            drawList.append(Font("Garamond", StyleType.ItalicStyle, 0, StretchType.NormalStretch))
            #italicfont = string.replace(textfont, "T", 'I')
#            font = ImageFont.load_path(italicfont)
        else:
            drawList.append(Font("Garamond", StyleType.NormalStyle, 0, StretchType.NormalStretch))
            #font = ImageFont.load_path(normalfont)
            #tw, th = font.getsize(textcopy)
        tw = 30
        th = 12
#        tw -= 2
#        th -= 2
        if 't' in textpos:
            y = th
        elif 'm' in textpos:
            y = (height/2) - th - 2
        else: # The default value is 'b'
            y = height - th - 2
        if 'l' in textalign:
            x = 2
        elif 'r' in textalign:
            x = (width - tw) - 2
        else: # The default value is 'c'
            x = (width - tw) / 2
       # draw = ImageDraw.Draw(img)
        textcol = self.hex_to_rbg(textcolor)
        drawList.append(Text(x, y, textcopy))
        drawList.append(FillColor(ColorRGB(textcol[0],textcol[1],textcol[2])))
        self.im.draw(drawList)


if __name__ == "__main__":
    file = open('/usr/photo/vrmvxi.jpg')
    data = file.read()
    img = PM_Image_modif(data)
    #img.getrotate(90)
    #img.invert_image()
    #img.gettextcopyright("supercool", ['t'],['m'],"", 12, textboldfont='1', textitalicfont='1',textcolor='#FFFFFF')
    #img.change_Brightness(30)
    img.resize_image(300,300)
    img.save_to('/tmp/res.jpg')
